[BACK]Return to update_openbsd CVS log [TXT][DIR] Up to [local] / openbsd / update_openbsd

Annotation of openbsd/update_openbsd/update_openbsd, Revision 1.50

1.1       andrew      1: #!/bin/sh
1.50    ! andrew      2: # $AFresh1: update_openbsd,v 1.49 2013/10/20 00:13:38 andrew Exp $
1.41      andrew      3: #
                      4: # Copyright (c) 2012 Andrew Fresh <andrew@afresh1.com>
                      5: #
                      6: # Permission to use, copy, modify, and distribute this software for any
                      7: # purpose with or without fee is hereby granted, provided that the above
                      8: # copyright notice and this permission notice appear in all copies.
                      9: #
                     10: # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
                     11: # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
                     12: # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
                     13: # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
                     14: # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
                     15: # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
                     16: # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
                     17: #
1.7       andrew     18:
1.2       andrew     19: installed_sets() {
1.5       andrew     20:     local misc=/usr/share/doc/README
                     21:     local man=/usr/share/man/cat1/intro.0
                     22:     local comp=/usr/bin/cc
                     23:     local game=/usr/games/
                     24:     local xbase=/usr/X11R6/
                     25:     local xetc=/etc/X11/xinit/xinitrc
                     26:     local xfont=/usr/X11R6/lib/X11/fonts
                     27:     local xserv=/usr/X11R6/bin/X
                     28:     local xshare=/usr/X11R6/bin/startx
                     29:
                     30:     local _c _d _e
                     31:     echo -n base
                     32:     echo -n ' etc'
1.3       andrew     33:     for _d in misc man comp game xbase xetc xfont xserv xshare; do
                     34:         eval _e=\$${_d}
                     35:         _c=`ls $_e 2> /dev/null | wc -l`
                     36:         #echo $_c $_d $_e
                     37:         if [ $_c -ne 0 ]; then
1.5       andrew     38:             echo -n " $_d"
1.2       andrew     39:         fi
                     40:     done
1.19      andrew     41:
1.34      andrew     42:     sendmail -d0.1 --badoption </dev/null 2>/dev/null | grep -q SASL
1.19      andrew     43:     if [ $? == 0 ]; then
                     44:         echo -n ' sendmail-smtp_auth'
                     45:     fi
1.2       andrew     46: }
1.7       andrew     47:
1.39      andrew     48: kernel_file_version() {
                     49:     echo exit | config -e $1 | grep -A1 ^OpenBSD
                     50:     #what $1 | sed -ne 's/[[:blank:]]\{1,\}//p'
                     51: }
                     52:
1.16      andrew     53: version_in() {
1.10      andrew     54:         local _proto=${FTP%%://*}
1.16      andrew     55:         local _file
1.10      andrew     56:
                     57:         if [ X"ftp" == X"${_proto}" ]; then
1.16      andrew     58:             local _list=`echo "ls base*.tgz" | ${FTP_CMD} ${FTP}/`
                     59:             _file=`echo ${_list} | awk '/base[0-9][0-9].tgz/ { print $9 }'`
1.15      andrew     60:
1.10      andrew     61:         elif [ X"http" == X"${_proto}" ]; then
1.16      andrew     62:             local _list=`${FTP_CMD} -V -o - ${FTP}/`
                     63:             _file=`echo ${_list} | awk '/[^x]base[0-9][0-9]*\.tgz/ {
1.15      andrew     64:                     sub("^.*base","base");
                     65:                     sub("\.tgz.*",".tgz");
                     66:                     print $0;
1.16      andrew     67:                 }'`
1.15      andrew     68:
                     69:         elif [ X"scp" == X"${_proto}" ]; then
                     70:             echo SCP is not yet supported >&2
                     71:             return 2
                     72:
1.10      andrew     73:         else
                     74:             echo Unsupported FTP ${FTP} >&2
1.12      andrew     75:             return 2
1.15      andrew     76:
1.10      andrew     77:         fi
1.16      andrew     78:
                     79:         local _v=${_file##*base}
                     80:         _v=${_v%.tgz*}
                     81:         echo $_v
1.10      andrew     82: }
1.2       andrew     83:
                     84: set_version() {
                     85:     CUR_VER=`uname -r`
1.3       andrew     86:     NEW_VER=`dc -e "$CUR_VER 0.1 + p"`
1.5       andrew     87:     FILE_VER=""
                     88:     FTP=""
1.2       andrew     89:
1.5       andrew     90:     local _cv=`echo $CUR_VER | sed -e 's/\.//'`
                     91:     local _nv=`echo $NEW_VER | sed -e 's/\.//'`
1.9       andrew     92:     local _v
1.5       andrew     93:
1.10      andrew     94:     if [ X"No" != X"$FORCE_DIR" -a -d $FORCE_DIR ]; then
1.5       andrew     95:         _dir=$FORCE_DIR
                     96:         if [ -e ${_dir}/base${_nv}.tgz ]; then
                     97:             _v=$_nv
                     98:         elif [ -e ${_dir}/base${_cv}.tgz ]; then
                     99:             NEW_VER=$CUR_VER
                    100:             _v=$_cv
                    101:         fi
1.2       andrew    102:
1.5       andrew    103:     elif [ -d $CUR_VER ]; then
                    104:         _dir=$CUR_VER
1.2       andrew    105:         NEW_VER=$CUR_VER
1.5       andrew    106:         if [ -e ${_dir}/base${_cv}.tgz ]; then
                    107:             _v=$_cv
                    108:         fi
1.2       andrew    109:
1.5       andrew    110:     elif [ -d $NEW_VER ]; then
                    111:         _dir=$NEW_VER
                    112:         if [ -e ${_dir}/base${_nv}.tgz ]; then
                    113:             _v=$_nv
                    114:         fi
1.2       andrew    115:
                    116:     fi
                    117:
1.17      andrew    118:     if [ X"" != X"${MIRROR}" -a X"" == X"${_v}" ]; then
1.10      andrew    119:         if [ X"No" == X"${FORCE_DIR}" ]; then
1.5       andrew    120:             _dir=${NEW_VER}
                    121:         else
                    122:             _dir=${FORCE_DIR}
                    123:         fi
                    124:         FTP=${MIRROR}/${_dir}/`machine`
1.2       andrew    125:
1.16      andrew    126:         _v=`version_in`
1.10      andrew    127:
1.16      andrew    128:         if [ X"" == X"${_v}" ]; then
1.10      andrew    129:             if [ X"No" != X"$FORCE_DIR" ]; then
                    130:                 echo No sets in forced [${FTP}] >&2
1.12      andrew    131:                 return 2
1.10      andrew    132:             fi
                    133:
                    134:             NEW_VER=$CUR_VER
                    135:             _dir=${NEW_VER}
                    136:             FTP=${MIRROR}/${_dir}/`machine`
                    137:
1.16      andrew    138:             _v=`version_in`
1.9       andrew    139:         fi
                    140:
1.10      andrew    141:         if [ X"" == X"${_v}" ]; then
1.16      andrew    142:             echo No sets in [${FTP}] >&2
1.12      andrew    143:             return 2
1.10      andrew    144:         elif [ X"${_cv}" == X"${_v}" ]; then
1.5       andrew    145:             NEW_VER=$CUR_VER
1.9       andrew    146:         elif [ X"${_nv}" == X"${_v}" ]; then
                    147:             NEW_VER=$NEW_VER
1.2       andrew    148:         else
1.10      andrew    149:             echo Invalid version [$_v] >&2
1.12      andrew    150:             return 2
1.2       andrew    151:         fi
                    152:
1.10      andrew    153:         if [ X"No" == X"$FORCE_DIR" ]; then
1.5       andrew    154:             _dir=$NEW_VER
1.2       andrew    155:         fi
                    156:
                    157:     fi
                    158:
1.5       andrew    159:     if [ X"" == X"${_v}" ]; then
                    160:         echo ERROR: Unable to determine file version! >&2
1.12      andrew    161:         return 1
1.2       andrew    162:     fi
                    163:
1.5       andrew    164:     if [ X"" == X"$RELEASEDIR" ]; then
                    165:         RELEASEDIR=`pwd`/$_dir
1.2       andrew    166:     fi
1.9       andrew    167:
1.5       andrew    168:     FILE_VER=$_v
1.17      andrew    169:     if [ X"" != X"${MIRROR}" ]; then
                    170:         FTP=${MIRROR}/${_dir}/`machine`
                    171:     fi
1.39      andrew    172:
                    173:     BOOT_KERNEL=`( \
                    174:         echo bsd; \
                    175:         [ -e /boot.conf ] && sed -E '/^ *(set +image|boot) +/!d ; \
                    176:             s///; s/^.*://; s/ .*$//' /boot.conf \
                    177:     ) | tail -1`
1.42      andrew    178:     BOOT_KERNEL=`follow_symlink /$BOOT_KERNEL`
1.39      andrew    179:     BOOT_KERNEL="/${BOOT_KERNEL#/}"
                    180:
                    181:     BOOT_KERNEL_VERSION=`kernel_file_version $BOOT_KERNEL`
                    182:
                    183:     BOOTED_KERNEL_VERSION=`sysctl -n kern.version`
                    184:     NEW_KERNEL_VERSION=""
                    185:
                    186:     # We want to default to what we had
                    187:     INSTALL_KERNELS="${BOOT_KERNEL#/}"
1.48      andrew    188:     # if the boot kernel was our specially named bsd.sp, we install from bsd
                    189:     if [ X"$INSTALL_KERNELS" == X"bsd.sp" ]; then
                    190:         INSTALL_KERNELS="bsd"
                    191:     fi
1.39      andrew    192:     # with a second option of an mp kernel if is is a likely candidate
                    193:     if [ X"$INSTALL_KERNELS" != X"bsd.mp" ]; then
                    194:         local _ncpu=$(sysctl -n hw.ncpufound)
                    195:         [ $_ncpu -gt 1 ] && INSTALL_KERNELS="$INSTALL_KERNELS bsd.mp"
                    196:     fi
                    197:     # or just bsd otherwise
                    198:     if [ X"${INSTALL_KERNELS% *}" != X"bsd" ]; then
                    199:         INSTALL_KERNELS="$INSTALL_KERNELS bsd"
                    200:     fi
                    201:     BOOT_KERNELS=$INSTALL_KERNELS
                    202:     INSTALL_KERNELS="$INSTALL_KERNELS bsd.rd"
1.2       andrew    203: }
                    204:
                    205: get_sets() {
1.5       andrew    206:     echo '### GETTING SETS ###'
1.2       andrew    207:     if [ X"" == X"$FTP" ]; then
1.5       andrew    208:         echo ERROR: No FTP site set! >&2
1.12      andrew    209:         return 1
1.2       andrew    210:     fi
                    211:
1.5       andrew    212:     mkdir -p ${RELEASEDIR}
                    213:     cd $RELEASEDIR
1.2       andrew    214:
1.5       andrew    215:     local _v=$FILE_VER
1.2       andrew    216:
1.39      andrew    217:     for _b in $INSTALL_KERNELS; do
1.45      andrew    218:         if [ ! -e ./${_b} ]; then
1.3       andrew    219:             echo $FTP_CMD ${FTP}/${_b}
                    220:             $FTP_CMD ${FTP}/${_b}
1.2       andrew    221:         fi
                    222:     done
                    223:
1.5       andrew    224:     for _s in $INSTALLED_SETS; do
1.19      andrew    225:         local _file=${_s}${_v}.tgz
                    226:         if [ ${_s} == sendmail-smtp_auth ]; then
                    227:             _file=${_s}.gz
                    228:         fi
                    229:
                    230:         if [ ! -e ./${_file} ]; then
                    231:             echo $FTP_CMD ${FTP}/${_file}
                    232:             $FTP_CMD ${FTP}/${_file}
1.5       andrew    233:         fi
1.2       andrew    234:     done
                    235:
1.20      andrew    236:     local _type
                    237:     for _type in $CHECKSUM_TYPES; do
1.40      andrew    238:         [ -e $_type ] && break
                    239:         echo $FTP_CMD ${FTP}/$_type
                    240:         $FTP_CMD ${FTP}/$_type
1.20      andrew    241:     done
1.17      andrew    242: }
                    243:
1.23      andrew    244: follow_symlink () {
                    245:     local _file=$1
1.33      andrew    246:     # This could go circular, but I dunno how to fix that.
                    247:     if [ -h $_file ]; then
                    248:         follow_symlink $( file $_file |
                    249:             grep 'symbolic link' |
                    250:             sed -e s/^.*\\\`// -e s/\\\'\$// )
1.23      andrew    251:     else
1.33      andrew    252:         echo $_file
1.23      andrew    253:     fi
                    254: }
                    255:
1.20      andrew    256: check_sum () {
                    257:     local _type=$1
                    258:     echo "### CHECKING $_type SUMS ###"
1.17      andrew    259:     cd $RELEASEDIR
                    260:
1.20      andrew    261:     if [ ! -e $_type ]; then
                    262:         echo $_type File does not exist!
1.17      andrew    263:         return 1
                    264:     fi
1.6       andrew    265:
1.19      andrew    266:     ls bsd* *gz | sed -e 's/\(.*\)/(\1)/' > index
1.20      andrew    267:     grep -f index $_type | sum -c
1.2       andrew    268:
                    269:     if [ $? -ne 0 ]; then
1.20      andrew    270:         echo ERROR: $_type does not match! >&2
1.12      andrew    271:         return 1
1.2       andrew    272:     fi
                    273: }
                    274:
1.17      andrew    275: check_sets() {
                    276:     echo '### CHECKING SETS ###'
                    277:     cd $RELEASEDIR
                    278:
1.18      andrew    279:     local _missing_sets
1.17      andrew    280:     local _v=$FILE_VER
                    281:
1.39      andrew    282:     for _n in $INSTALL_KERNELS; do
                    283:         local _o=$_n
                    284:         [ X"bsd" == X"${_o}" -a -e /bsd.sp ] && _o=bsd.sp
                    285:         if [ -e /${_o} -a ! -e ./${_n} ]; then
                    286:             echo ${_o} does not exist
                    287:             _missing_sets=1
1.17      andrew    288:         fi
1.39      andrew    289:
                    290:         if [ X"${BOOT_KERNEL}" == X"/${_o}" -a -e ./${_n} ]; then
                    291:             NEW_KERNEL_VERSION=`kernel_file_version ./${_n}`
1.17      andrew    292:         fi
                    293:     done
                    294:
1.39      andrew    295:     if [ X"$NEW_KERNEL_VERSION" == X"" ]; then
                    296:         echo Missing replacement for boot kernel $BOOT_KERNEL >&2
                    297:         _missing_sets=1
                    298:     fi
                    299:
1.17      andrew    300:     for _s in $INSTALLED_SETS; do
1.19      andrew    301:         local _file=${_s}${_v}.tgz
                    302:         if [ ${_s} == sendmail-smtp_auth ]; then
                    303:             _file=${_s}.gz
                    304:         fi
                    305:         if [ ! -e ./${_file} ]; then
                    306:             echo ${_file} does not exist
1.18      andrew    307:             _missing_sets=1
1.17      andrew    308:         fi
                    309:     done
1.18      andrew    310:
                    311:     if [ X"" == X"${_missing_sets}" ]; then
                    312:         echo All OK
                    313:     fi
1.17      andrew    314:
1.20      andrew    315:     local _type
                    316:     for _type in $CHECKSUM_TYPES; do
                    317:         if [ -e $_type ]; then
                    318:             check_sum $_type
                    319:         fi
                    320:     done
1.17      andrew    321: }
                    322:
                    323:
1.30      andrew    324: install_kernels() {
1.5       andrew    325:     echo '### INSTALLING KERNEL ###'
1.3       andrew    326:     if [ X"$USER" != X"root" -a X"$SUDO" == X"" ]; then
1.2       andrew    327:         echo ${0##*/} must be run as root or SUDO must be set! >&2
                    328:         exit 1
                    329:     fi
                    330:
                    331:     if [ X"" == X"$RELEASEDIR" ]; then
1.5       andrew    332:         echo ERROR: no source for new kernels! >&2
1.2       andrew    333:         exit 1
                    334:     fi
                    335:
1.46      andrew    336:     if [ X"$BOOT_KERNEL_VERSION" != X"$NEW_KERNEL_VERSION" ]; then
                    337:         echo "Backing up $BOOT_KERNEL to /obsd"
                    338:         $SUDO ln -f $BOOT_KERNEL /obsd
                    339:         if [ $? -ne 0 ]; then
                    340:             echo "Error copying old kernel!" >&2
                    341:             exit 1
                    342:         fi
1.2       andrew    343:     fi
                    344:
1.39      andrew    345:     cd $RELEASEDIR
1.23      andrew    346:
1.39      andrew    347:     for _b in $INSTALL_KERNELS; do
1.3       andrew    348:         $SUDO rm -f /nbsd
1.39      andrew    349:         local _bd=$_b
                    350:         [ X"${_b}" == X"bsd" ] && _bd="bsd.sp"
1.2       andrew    351:
1.39      andrew    352:         local _is_boot=""
                    353:         [ X"$BOOT_KERNEL" == X"/${_bd}" ] && _is_boot="# boot kernel"
                    354:
                    355:         echo "Copying $_b to /$_bd $_is_boot"
                    356:         $SUDO cp ${_b} /nbsd && $SUDO mv /nbsd /${_bd}
1.2       andrew    357:         if [ $? -ne 0 ]; then
1.39      andrew    358:             echo ERROR: Could not copy new $_bd kernel! >&2
1.2       andrew    359:             exit 1
                    360:         fi
1.39      andrew    361:     done
                    362:
                    363:     cd $OLDPWD
1.23      andrew    364:
1.39      andrew    365:     if [ ! -h /bsd ]; then
                    366:            cd /
                    367:         for _b in $BOOT_KERNELS; do
                    368:             [ X"$_b" == X"bsd" ] && _b="bsd.sp"
                    369:             if [ -e $_b ]; then
                    370:                 echo symlinking $_b to /bsd
                    371:                 $SUDO ln -sf $_b bsd
                    372:                 if [ $? -ne 0 ]; then
                    373:                     echo ERROR: Could not symlink new kernel! >&2
                    374:                     exit 1
                    375:                 fi
                    376:                 break
                    377:             fi
                    378:         done
                    379:            cd $OLDPWD
1.2       andrew    380:     fi
                    381: }
                    382:
                    383: install_sets() {
1.5       andrew    384:     echo '### INSTALLING SETS ###'
1.3       andrew    385:     if [ X"$USER" != X"root" -a X"$SUDO" == X"" ]; then
1.2       andrew    386:         echo ${0##*/} must be run as root or SUDO must be set! >&2
                    387:         exit 1
                    388:     fi
                    389:
                    390:     if [ X"" == X"$RELEASEDIR" ]; then
1.5       andrew    391:         echo ERROR: no source for sets! >&2
1.2       andrew    392:         exit 1
                    393:     else
                    394:         cd $RELEASEDIR
                    395:     fi
                    396:
1.5       andrew    397:     local _v=$FILE_VER
                    398:
1.21      andrew    399:     local _sets=`ls *${_v}.tgz | grep -v ^base `
                    400:     for _f in ${_sets} base${_v}.tgz; do
1.3       andrew    401:         _path=$DESTDIR
                    402:         if [ X"etc${_v}.tgz"  == X"$_f" \
                    403:             -o X"xetc${_v}.tgz" == X"$_f" ]; then
1.21      andrew    404:             [ X"" != X"$SYSMERGE" ] && continue
1.2       andrew    405:             _path=/var/tmp/temproot
                    406:         fi
                    407:
1.3       andrew    408:         echo Extracting $_f to $_path
                    409:         $SUDO mkdir -p $_path
                    410:         $SUDO tar -C $_path -xzphf ${RELEASEDIR}/${_f}
1.2       andrew    411:         if [ $? -ne 0 ]; then
1.5       andrew    412:             echo ERROR: Could not extract ${_f}! >&2
1.2       andrew    413:             exit 1
                    414:         fi
                    415:     done
                    416:
                    417:     echo Extracted all sets.
1.19      andrew    418:
                    419:     if [ -e ${RELEASEDIR}/sendmail-smtp_auth.gz ]; then
                    420:         gzcat ${RELEASEDIR}/sendmail-smtp_auth.gz > \
                    421:             ${RELEASEDIR}/sendmail-smtp_auth
                    422:     fi
                    423:     if [ -e ${RELEASEDIR}/sendmail-smtp_auth ]; then
1.21      andrew    424:         if ! pkg_info -qe 'cyrus-sasl-*'; then
                    425:             $SUDO pkg_add -i cyrus-sasl
                    426:         fi
                    427:
                    428:         $SUDO install -o root -g smmsp -m 2555 \
1.19      andrew    429:             ${RELEASEDIR}/sendmail-smtp_auth \
1.21      andrew    430:             /usr/libexec/sendmail/sendmail
1.19      andrew    431:
                    432:         echo Installed sendmail with smtp_auth
                    433:     fi
1.2       andrew    434: }
                    435:
                    436: update_etc() {
1.5       andrew    437:     echo '### UPDATING ETC ###'
1.10      andrew    438:     if [ ! -e $SYSMERGE ]; then
1.47      andrew    439:         echo "ERROR: Can't find sysmerge!" >&2
                    440:         exit 1;
1.10      andrew    441:     fi
                    442:
1.47      andrew    443:     if [ X"" == X"$RELEASEDIR" ]; then
                    444:         echo "ERROR: no source for etc!" >&2
                    445:         exit 1
                    446:     fi
1.2       andrew    447:
1.47      andrew    448:     cd $RELEASEDIR
1.5       andrew    449:
1.47      andrew    450:     local _v=$FILE_VER
                    451:     local _args=""
                    452:     if [ -e etc${_v}.tgz ]; then
                    453:         _args="$_args -s etc${_v}.tgz"
                    454:     fi
                    455:     if [ -e xetc${_v}.tgz ]; then
                    456:         _args="$_args -x xetc${_v}.tgz"
                    457:     fi
                    458:     if [ X"" == X"$_args" ]; then
                    459:         echo ERROR: No upgrade sets found! >&2
1.2       andrew    460:     else
1.47      andrew    461:         echo '### RUNNING SYSMERGE ###'
                    462:         $SUDO $SYSMERGE $_args
                    463:     fi
1.2       andrew    464:
1.47      andrew    465:     cd $OLDPWD
1.2       andrew    466: }
1.14      andrew    467:
1.20      andrew    468:
1.14      andrew    469: if [ -e /etc/update_openbsd.conf ]; then
                    470:     . /etc/update_openbsd.conf
                    471: fi
                    472:
                    473: if [ -e ${HOME}/.update_openbsdrc ]; then
                    474:     . ${HOME}/.update_openbsdrc
                    475: fi
                    476:
1.17      andrew    477: #MIRROR=${MIRROR:=ftp://ftp.openbsd.org/pub/OpenBSD}
1.14      andrew    478: FTP_CMD=${FTP_CMD:=ftp -V}
                    479: PKG_PATH=${PKG_PATH:=/usr/ports/packages/`machine`/all/:${MIRROR}/`uname -r`/packages/`machine`/}
                    480:
                    481: DESTDIR=${DESTDIR:=/}
                    482: SYSMERGE=${SYSMERGE:=/usr/sbin/sysmerge}
                    483: FORCE_DIR=${FORCE_DIR:=No}
                    484:
                    485: INSTALLED_SETS=${INSTALLED_SETS:=`installed_sets`}
1.2       andrew    486:
1.21      andrew    487: CHECKSUM_TYPES=${CHECKSUM_TYPES:=SHA256 MD5}
1.20      andrew    488:
1.2       andrew    489: set_version
1.12      andrew    490: local _error=$?
1.2       andrew    491:
                    492: echo
                    493: echo "-= update_openbsd - helper script to update OpenBSD =-"
                    494: echo "------------------------------------------------------"
                    495: echo
1.39      andrew    496: echo "           SUDO: $SUDO"
                    497: echo "       SYSMERGE: $SYSMERGE"
                    498: echo "         MIRROR: $MIRROR"
                    499: echo "     RELEASEDIR: $RELEASEDIR"
                    500: echo "        DESTDIR: $DESTDIR"
                    501: echo "    BOOT_KERNEL: $BOOT_KERNEL"
                    502: echo "INSTALL_KERNELS: $INSTALL_KERNELS"
                    503: echo " INSTALLED_SETS: $INSTALLED_SETS"
1.8       andrew    504: echo
1.39      andrew    505: echo "        CUR_VER: $CUR_VER"
                    506: echo "        NEW_VER: $NEW_VER"
                    507: #echo "       FILE_VER: $FILE_VER"
1.2       andrew    508: echo
1.12      andrew    509:
                    510: if [ ${_error} -ne 0 ]; then
                    511:        exit ${_error}
                    512: fi
1.2       andrew    513:
1.17      andrew    514: if [ X"" != X"${FTP}" ]; then
1.20      andrew    515:     get_sets
1.17      andrew    516: fi
                    517:
                    518: check_sets || exit
1.39      andrew    519:
                    520: echo "Last booted:\n$BOOTED_KERNEL_VERSION"
                    521: if [ X"$BOOT_KERNEL_VERSION" != X"$BOOTED_KERNEL_VERSION" \
                    522:   -a X"$BOOT_KERNEL_VERSION" != X"$NEW_KERNEL_VERSION" ]; then
                    523:     echo "Next boot (unless replaced):\n$BOOT_KERNEL_VERSION"
                    524: fi
                    525: if [ -n "$NEW_KERNEL_VERSION" ]; then
                    526:     echo "New $BOOT_KERNEL:\n$NEW_KERNEL_VERSION";
                    527: else
                    528:     echo "\n!!! WARNING: Will not replace boot kernel $BOOT_KERNEL! !!!\n" >&2
                    529:     echo "ctrl+C to cancel, enter to continue anyway" >&2
1.44      andrew    530:     local _temp
                    531:     read _temp
                    532: fi
                    533:
                    534: if [ -n "$SUDO" -a $CUR_VER != $NEW_VER ]; then
                    535:     echo >&2
                    536:     echo "!!! You are upgrading between OpenBSD versions.     !!!" >&2
                    537:     echo "!!! You should make sure you have a root shell open !!!" >&2
                    538:     echo "!!! It is needed in order to run /sbin/oreboot.     !!!" >&2
                    539:     echo "!!! sudo MAY NOT WORK after sets are extracted.     !!!" >&2
                    540:     echo >&2
                    541:     echo "ctrl+C to cancel, enter to continue" >&2
1.39      andrew    542:     local _temp
                    543:     read _temp
                    544: fi
1.2       andrew    545:
1.43      andrew    546: if [ -n "$SUDO" ]; then
                    547:     echo
                    548:     echo You may be asked for your sudo password multiple times.
                    549:     $SUDO -v -p "sudo Password: "
1.50    ! andrew    550: fi
        !           551:
        !           552: if [ X"$BOOT_KERNEL_VERSION" != X"$BOOTED_KERNEL_VERSION" \
        !           553:      -a ! -e /sbin/oreboot ]; then
        !           554:     $SUDO cp /sbin/reboot /sbin/oreboot
        !           555:     if [ $? -ne 0 ]; then
        !           556:         echo "Error copying old reboot command!" >&2
        !           557:         exit 1
        !           558:     fi
        !           559:     echo "/sbin/reboot copied to /sbin/oreboot"
1.2       andrew    560: fi
                    561:
1.30      andrew    562: install_kernels
1.21      andrew    563: install_sets
1.2       andrew    564:
1.49      andrew    565: if [ X"$BOOT_KERNEL_VERSION" == X"$BOOTED_KERNEL_VERSION" ]; then
1.21      andrew    566:     if [ -e /sbin/oreboot ]; then
                    567:         echo Removing /sbin/oreboot
                    568:         $SUDO rm -f /sbin/oreboot
                    569:     fi
1.2       andrew    570:     update_etc
                    571:
                    572:     echo '### UPDATING PACKAGES ###'
                    573:     $SUDO pkg_add -ui -F update -F updatedepends
                    574:
                    575: else
                    576:     echo Instructions for updating to the new version available from
1.36      andrew    577:     if [ X"snapshots" == X"$FORCE_DIR" ]; then
1.30      andrew    578:         echo "  http://www.openbsd.org/faq/current.html"
                    579:     else
                    580:         echo "  http://www.openbsd.org/faq/upgrade${FILE_VER}.html"
                    581:     fi
1.2       andrew    582: fi
                    583:
                    584: echo New kernel installed.  Please reboot!
1.22      andrew    585: if [ -e /sbin/oreboot ]; then
                    586:     echo Possibly using /sbin/oreboot
1.31      andrew    587: fi
                    588:
                    589: local _send_dmesg=`dirname $0`/send_dmesg
                    590: if [ -e "$_send_dmesg" ]; then
1.32      andrew    591:     if [ -e $RELEASEDIR/.send_dmesg ]; then
1.31      andrew    592:         $_send_dmesg
                    593:         rm -f $RELEASEDIR/.send_dmesg
1.32      andrew    594:     elif [ X"$CUR_VER" != X"$NEW_VER" ]; then
1.31      andrew    595:         touch $RELEASEDIR/.send_dmesg
                    596:     fi
1.22      andrew    597: fi

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>